Index: crt/string/strtoi64.c
===================================================================
--- crt/string/strtoi64.c	(revision 47065)
+++ crt/string/strtoi64.c	(working copy)
@@ -1,12 +1,156 @@
 #include <precomp.h>
 
+/*********************************************************************
+ *  _strtoi64_l (MSVCR90.@)
+ *
+ * FIXME: locale parameter is ignored
+ */
+__int64 CDECL _strtoi64_l(const char *nptr, char **endptr, int base, _locale_t locale)
+{
+    BOOL negative = FALSE;
+    __int64 ret = 0;
 
+    TRACE("(%s %p %d %p)\n", nptr, endptr, base, locale);
+
+    if(!nptr || base<0 || base>36 || base==1) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        return 0;
+    }
+
+    while(isspace(*nptr)) nptr++;
+
+    if(*nptr == '-') {
+        negative = TRUE;
+        nptr++;
+    } else if(*nptr == '+')
+        nptr++;
+
+    if((base==0 || base==16) && *nptr=='0' && tolower(*(nptr+1))=='x') {
+        base = 16;
+        nptr += 2;
+    }
+
+    if(base == 0) {
+        if(*nptr=='0')
+            base = 8;
+        else
+            base = 10;
+    }
+
+    while(*nptr) {
+        char cur = tolower(*nptr);
+        int v;
+
+        if(isdigit(cur)) {
+            if(cur >= '0'+base)
+                break;
+            v = cur-'0';
+        } else {
+            if(cur<'a' || cur>='a'+base-10)
+                break;
+            v = cur-'a'+10;
+        }
+
+        if(negative)
+            v = -v;
+
+        nptr++;
+
+        if(!negative && (ret>INT64_MAX/base || ret*base>INT64_MAX-v)) {
+            ret = INT64_MAX;
+            *_errno() = ERANGE;
+        } else if(negative && (ret<INT64_MIN/base || ret*base<INT64_MIN-v)) {
+            ret = INT64_MIN;
+            *_errno() = ERANGE;
+        } else
+            ret = ret*base + v;
+    }
+
+    if(endptr)
+        *endptr = (char*)nptr;
+
+    return ret;
+}
+
 __int64
 _strtoi64(const char *nptr, char **endptr, int base)
 {
-   TRACE("_strtoi64 is UNIMPLEMENTED\n");
-   return 0;
+   return _strtoi64_l(nptr, endptr, base, NULL);
 }
 
+/*********************************************************************
+ *  _strtoui64_l (MSVCR90.@)
+ *
+ * FIXME: locale parameter is ignored
+ */
+unsigned __int64 CDECL _strtoui64_l(const char *nptr, char **endptr, int base, _locale_t locale)
+{
+    BOOL negative = FALSE;
+    unsigned __int64 ret = 0;
 
+    TRACE("(%s %p %d %p)\n", nptr, endptr, base, locale);
+
+    if(!nptr || base<0 || base>36 || base==1) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        return 0;
+    }
+
+    while(isspace(*nptr)) nptr++;
+
+    if(*nptr == '-') {
+        negative = TRUE;
+        nptr++;
+    } else if(*nptr == '+')
+        nptr++;
+
+    if((base==0 || base==16) && *nptr=='0' && tolower(*(nptr+1))=='x') {
+        base = 16;
+        nptr += 2;
+    }
+
+    if(base == 0) {
+        if(*nptr=='0')
+            base = 8;
+        else
+            base = 10;
+    }
+
+    while(*nptr) {
+        char cur = tolower(*nptr);
+        int v;
+
+        if(isdigit(cur)) {
+            if(cur >= '0'+base)
+                break;
+            v = *nptr-'0';
+        } else {
+            if(cur<'a' || cur>='a'+base-10)
+                break;
+            v = cur-'a'+10;
+        }
+
+        nptr++;
+
+        if(ret>UINT64_MAX/base || ret*base>UINT64_MAX-v) {
+            ret = UINT64_MAX;
+            *_errno() = ERANGE;
+        } else
+            ret = ret*base + v;
+    }
+
+    if(endptr)
+        *endptr = (char*)nptr;
+
+    return negative ? -ret : ret;
+}
+
+/*********************************************************************
+ *  _strtoui64 (MSVCR90.@)
+ */
+unsigned __int64 CDECL _strtoui64(const char *nptr, char **endptr, int base)
+{
+    return _strtoui64_l(nptr, endptr, base, NULL);
+}
+
+
 /* EOF */
Index: crt/string/strtok.c
===================================================================
--- crt/string/strtok.c	(revision 47065)
+++ crt/string/strtok.c	(working copy)
@@ -2,61 +2,53 @@
 #include <precomp.h>
 
 #include <string.h>
+#include <internal/wine/msvcrt.h>
 #include <internal/tls.h>
 
-char** _lasttoken(); /* lasttok.c */
+/*********************************************************************
+ *		strtok  (MSVCRT.@)
+ */
+char* strtok(char* str, const char* delim)
+{
+    MSVCRT_thread_data *data = msvcrt_get_thread_data();
+    char *ret;
 
-/*
- * @implemented
+    if (!str)
+        if (!(str = data->strtok_next)) return NULL;
+
+    while (*str && strchr( delim, *str )) str++;
+    if (!*str) return NULL;
+    ret = str++;
+    while (*str && !strchr( delim, *str )) str++;
+    if (*str) *str++ = 0;
+    data->strtok_next = str;
+    return ret;
+}
+
+/*********************************************************************
+ *		strtok_s  (MSVCRT.@)
  */
-char* strtok(char* s, const char* delim)
+char * CDECL strtok_s(char *str, const char *delim, char **ctx)
 {
-  const char *spanp;
-  int c, sc;
-  char *tok;
-#if 1
-  char ** lasttoken = _lasttoken();
-#else
-  PTHREADDATA ThreadData = GetThreadData();
-  char ** lasttoken = &ThreadData->lasttoken;
-#endif
+    if(!delim || !ctx || (!str && !*ctx)) {
+        _invalid_parameter(NULL, NULL, NULL, 0, 0);
+        *_errno() = EINVAL;
+        return NULL;
+    }
 
-  if (s == NULL && (s = *lasttoken) == NULL)
-    return (NULL);
+    if(!str)
+        str = *ctx;
 
-  /*
-   * Skip (span) leading delimiters (s += strspn(s, delim), sort of).
-   */
- cont:
-  c = *s++;
-  for (spanp = delim; (sc = *spanp++) != 0;) {
-    if (c == sc)
-      goto cont;
-  }
+    while(*str && strchr(delim, *str))
+        str++;
+    if(!*str)
+        return NULL;
 
-  if (c == 0) {			/* no non-delimiter characters */
-    *lasttoken = NULL;
-    return (NULL);
-  }
-  tok = s - 1;
+    *ctx = str+1;
+    while(**ctx && !strchr(delim, **ctx))
+        (*ctx)++;
+    if(**ctx)
+        *(*ctx)++ = 0;
 
-  /*
-   * Scan token (scan for delimiters: s += strcspn(s, delim), sort of).
-   * Note that delim must have one NUL; we stop if we see that, too.
-   */
-  for (;;) {
-    c = *s++;
-    spanp = delim;
-    do {
-      if ((sc = *spanp++) == c) {
-	if (c == 0)
-	  s = NULL;
-	else
-	  s[-1] = 0;
-	*lasttoken = s;
-	return (tok);
-      }
-    } while (sc != 0);
-  }
-  /* NOTREACHED */
+    return str;
 }
Index: crt/string/strtold.c
===================================================================
--- crt/string/strtold.c	(revision 47065)
+++ crt/string/strtold.c	(working copy)
@@ -1,6 +1,6 @@
 /* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
 #include <stdlib.h>
-#include <msvcrt/ctype.h>
+#include <ctype.h>
 
 static double powten[] =
 {
@@ -13,7 +13,7 @@
 };
 
 long double
-_strtold(const char *s, char **sret)
+strtold(const char *s, char **sret)
 {
   double r;		/* result */
   int e, ne;			/* exponent */
